/*********************\
*                     *
*  Shows font dialog  *
*                     *
\*********************/

#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>

#include "fontdialog.h"
#include "debug.h"

static void (*CB)(char *,void *);
static GtkWidget *fontselectiondialog1;

static void
on_cancel_button1_clicked(GtkButton *button, gpointer user_data)
{

	DTP("on_cancel_button1_clicked()\n");

	gtk_widget_hide(fontselectiondialog1);
	gtk_grab_remove(fontselectiondialog1);
	gtk_widget_destroy(fontselectiondialog1);
}

static void
on_ok_button1_clicked(GtkButton *button, gpointer user_data)
{
	DTP("on_ok_button1_clicked()\n");

	if (CB) (*CB)(gtk_font_selection_dialog_get_font_name(GTK_FONT_SELECTION_DIALOG(fontselectiondialog1)),user_data);
	on_cancel_button1_clicked(button,user_data);
}

void
FontDialog(char *Default,void (*CallBack)(char *,void *),void *UserData)
{
  GtkWidget *ok_button1;
  GtkWidget *cancel_button1;
  GtkWidget *apply_button1;
  GtkAccelGroup *accel_group;

	DTP("FontDialog()\n");

	CB = CallBack;

  accel_group = gtk_accel_group_new ();

  fontselectiondialog1 = gtk_font_selection_dialog_new ("Select Font");
  gtk_object_set_data (GTK_OBJECT (fontselectiondialog1), "fontselectiondialog1", fontselectiondialog1);
  gtk_container_set_border_width (GTK_CONTAINER (fontselectiondialog1), 4);
  gtk_window_set_policy (GTK_WINDOW (fontselectiondialog1), FALSE, TRUE, TRUE);

  ok_button1 = GTK_FONT_SELECTION_DIALOG (fontselectiondialog1)->ok_button;
  gtk_object_set_data (GTK_OBJECT (fontselectiondialog1), "ok_button1", ok_button1);
  gtk_widget_show (ok_button1);
  GTK_WIDGET_SET_FLAGS (ok_button1, GTK_CAN_DEFAULT);
  gtk_widget_add_accelerator (ok_button1, "clicked", accel_group,
                              GDK_Return, 0,
                              GTK_ACCEL_VISIBLE);
  gtk_widget_add_accelerator (ok_button1, "clicked", accel_group,
                              GDK_KP_Enter, 0,
                              GTK_ACCEL_VISIBLE);

  cancel_button1 = GTK_FONT_SELECTION_DIALOG (fontselectiondialog1)->cancel_button;
  gtk_object_set_data (GTK_OBJECT (fontselectiondialog1), "cancel_button1", cancel_button1);
  gtk_widget_show (cancel_button1);
  GTK_WIDGET_SET_FLAGS (cancel_button1, GTK_CAN_DEFAULT);
  gtk_widget_add_accelerator (cancel_button1, "clicked", accel_group,
                              GDK_Escape, 0,
                              GTK_ACCEL_VISIBLE);

  apply_button1 = GTK_FONT_SELECTION_DIALOG (fontselectiondialog1)->apply_button;
  gtk_object_set_data (GTK_OBJECT (fontselectiondialog1), "apply_button1", apply_button1);
  GTK_WIDGET_SET_FLAGS (apply_button1, GTK_CAN_DEFAULT);

  gtk_signal_connect_after (GTK_OBJECT (ok_button1), "clicked",
                            GTK_SIGNAL_FUNC (on_ok_button1_clicked),
                            UserData);
  gtk_signal_connect_after (GTK_OBJECT (cancel_button1), "clicked",
                            GTK_SIGNAL_FUNC (on_cancel_button1_clicked),
                            UserData);

  gtk_window_add_accel_group (GTK_WINDOW (fontselectiondialog1), accel_group);

	if (Default) {
		gtk_font_selection_dialog_set_font_name(GTK_FONT_SELECTION_DIALOG(fontselectiondialog1),Default);
	}

	gtk_grab_add(fontselectiondialog1);
	gtk_widget_show(fontselectiondialog1);
}
