/************************\
*                        *
*  Implements TCADFrame  *
*                        *
\************************/

#include "frame.h"
#include "view.h"
#include "sheet.h"

void
TCADFrame::Save(TCADSaveStream *Fl)
{
	DTP("TCADFrame::Save()\n");

	if ((Fl->SaveOnlySelected) && !(Selected)) return;

  Fl->SaveObjectName("TCADFrame");
  SaveProperties(Fl);
  Fl->SaveEndObject();  
}

void
TCADFrame::SaveProperties(TCADSaveStream *Fl)
{
	DTP("TCADFrame::SaveProperties()\n");

  SaveLineProperties(Fl);
  TCADObject::SaveProperties(Fl);
}

char
TCADFrame::LoadProperty(TCADLoadStream *Fl,char *ID)
{
	DTP("TCADFrame::LoadProperty()\n");

  if (TCADLinePropertiesI::LoadProperty(Fl,ID)) return(TRUE);
  else return(TCADObject::LoadProperty(Fl,ID));
}

void
TCADFrame::Draw(TCADView *View,GdkRegion *Region,int MagA,int MagB)
{
//	DTP("TCADFrame::Draw()\n");

  if (Region)
   if (gdk_region_rect_in(Region, &EncapRect) == GDK_OVERLAP_RECTANGLE_OUT) return;

	SetupGC(View->GC);
  gdk_draw_rectangle(View->GetDrawable(),View->GC,0,EncapRect.x*MagA/MagB,EncapRect.y*MagA/MagB,(EncapRect.width-1)*MagA/MagB,(EncapRect.height-1)*MagA/MagB);
}

void
TCADFrame::Select(GdkRectangle *RefreshRect)
{
	DTP("TCADFrame::Select()\n");

//	printf("TCADFrame::Select()\n");
  TCADRectangleObject::Select(RefreshRect);
  UpdateHandlePos();
}

void
TCADFrame::Export(FILE *Fl,TExportFormat Format)
{
	DTP("TCADFrame::Export()\n");

  switch(Format) {
    case EF_LATEX:
      int x,y;
      x = EncapRect.x;
      y = Sheet->EncapRect.height-EncapRect.y-EncapRect.height;
      fprintf(Fl,"\\put(%d,%d){\\framebox(%d,%d){}}\n",x,y,EncapRect.width,EncapRect.height);
      break;
    case EF_FIG:
      ExportFigFrame(Fl,XFigLineStyle());
      break;
		case EF_EPS:
			ExportPSLineStyle(Fl);
			ExportPSFrame(Fl);
			fputc('\n',Fl);
			break;
  }
}
