/*********\
*         *
*  Frame  *
*         *
\*********/

#ifndef GTKFIG_FRAME_H
#define GTKFIG_FRAME_H

#include "rectangleobject.h"
#include "lineproperties.h"

class TCADView;

/*
 * Frame
 */
class TCADFrame : public TCADRectangleObject, public TCADLinePropertiesI {
public:
  TCADFrame(TCADSheet *Sheet) : TCADRectangleObject(Sheet) { }

  virtual void Save(TCADSaveStream *Fl);
  virtual void SaveProperties(TCADSaveStream *Fl);
  virtual char LoadProperty(TCADLoadStream *Fl,char *ID);
  virtual void Export(FILE *Fl,TExportFormat Format);

  virtual void Draw(TCADView *View,GdkRegion *Region,int MagA,int MagB);

  virtual void Select(GdkRectangle *RefreshRect);

	virtual void ShowLineProperties(TCADSheet *Obj) { TCADLinePropertiesI::ShowLineProperties(Obj); }
	virtual void SetLineProperties(int Style,int Width) { TCADLinePropertiesI::SetLineProperties(Style,Width); }

	virtual gboolean HasLineProperties() { return TRUE; }
};

#endif

