/*******************\
*                   *
*  Line properties  *
*                   *
\*******************/

#ifndef GTKFIG_LINEPROPERTIES_H
#define GTKFIG_LINEPROPERTIES_H

#include <gdk/gdk.h>
#include <gtk/gtkwidget.h>
#include "streams.h"

class TCADObject;
class TCADSheet;

/*
 * Defines interface of line properties
 */
class TCADLinePropertiesI {
protected:
  GdkColor *LineColor;
  gint LineWidth;
	gint LineStyle;

	const int NUM_STYLES=6;

  void SaveLineProperties(TCADSaveStream *Fl);
  char LoadProperty(TCADLoadStream *Fl,char *ID);

	// For dialog
	GtkWidget *Dialog;
	GdkGC *GC;
	GdkColor WhiteColor;
	GdkColor BlackColor;
  GtkWidget *RB_LS[NUM_STYLES];
	TCADSheet *LP_Sheet;
	GtkWidget *SB_Width;

	GtkWidget *CreateDialog();
public:
  TCADLinePropertiesI();
  ~TCADLinePropertiesI();

	virtual gboolean HasLineProperties() { return TRUE; };

  // Shows line properties dialog
  void ShowLineProperties(TCADSheet *Sheet);

	// Sets up GC to line properties
	void SetupGC(GdkGC *GC);

  // For callbacks only
	void DoDraw(GtkWidget *Widget);
	void CloseDialog();
	void GetSettings();

	// For settings after dialog is finished
	void SetLineProperties(int Style,int Width);

	// Gets line style in xfig numbering
	int XFigLineStyle();
	
	// Saves PS commands to set line style
	void ExportPSLineStyle(FILE *Fl);
};

#endif

