/**********************************************************\
*                                                          *
*  Receives menu signals and calls methods of main widget  *
*                                                          *
\**********************************************************/

#include <gtk/gtkmenuitem.h>
#include <gtk/gtkbutton.h>
#include <gtk/gtkmain.h>
#include "main.h"
#include "gladesig.h"
#include "messagebox.h"

void
on_New_activate(GtkMenuItem *menuitem, gpointer user_data)
{
	DTP("on_New_activate()\n");

  menuitem = menuitem; user_data=user_data;
  System->Menu_New();
}

void
on_Open_activate(GtkMenuItem *menuitem, gpointer user_data)
{
	DTP("on_Open_activate()\n");

  menuitem = menuitem; user_data=user_data;
  System->Menu_Open();
}

void
on_Save_all_activate(GtkMenuItem *menuitem, gpointer user_data)
{
	DTP("on_Save_all_activate()\n");

  menuitem = menuitem; user_data=user_data;
  System->Menu_SaveAll();
}

void
on_Exit_activate(GtkMenuItem *menuitem, gpointer user_data)
{
	DTP("on_Exit_activate()\n");

  menuitem = menuitem; user_data=user_data;
  System->Menu_Exit();
}

void
on_Next_activate(GtkMenuItem *menuitem, gpointer user_data)
{
	DTP("on_Next_activate()\n");

  menuitem = menuitem; user_data=user_data;
  System->Menu_NextWindow();
}

void
on_Previous_activate(GtkMenuItem *menuitem, gpointer user_data)
{
	DTP("on_Previous_activate()\n");

  menuitem = menuitem; user_data=user_data;
  System->Menu_PrevWindow();
}

void
on_Close_activate(GtkMenuItem *menuitem, gpointer user_data)
{
	DTP("on_Close_activate()\n");

  menuitem = menuitem; user_data=user_data;
  System->Menu_CloseWindow();
}

void
on_About_activate(GtkMenuItem *menuitem, gpointer user_data)
{
	DTP("on_About_activate()\n");

  menuitem = menuitem; user_data=user_data;
  System->Menu_About();
}

// Not actually menu signal
gboolean
on_MainWindow_delete_event(GtkWidget *widget, GdkEvent *event, gpointer user_data)
{
  widget=widget; event=event; user_data=user_data;

	DTP("on_MainWindow_delete_event()\n");

  if (gtk_grab_get_current() != NULL) return(TRUE);  // Modal dialog is showing

  System->Menu_Exit();

  return(FALSE);
}

void
on_MILAL_None_activate(GtkMenuItem *menuitem, gpointer user_data)
{
	DTP("on_MILAL_None_activate()\n");

  menuitem = menuitem;
  user_data = user_data;
}

void
on_MILAL_Grid_activate(GtkMenuItem *menuitem, gpointer user_data)
{
	DTP("on_MILAL_Grid_activate()\n");

  menuitem = menuitem;
  user_data = user_data;
}

void
on_MILAL_HalfGrid_activate(GtkMenuItem *menuitem, gpointer user_data)
{
	DTP("on_MILAL_HalfGrid_activate()\n");

  menuitem = menuitem;
  user_data = user_data;
}


