#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <gdk/gdkkeysyms.h>

#include "messagedlg.h"
#include "debug.h"

static void (*DCallBack)(int,gpointer);
static gpointer DUserData;
static GtkWidget *Dialog;

static void
on_clicked(GtkButton *button, gpointer user_data)
{
	int Pos=(int)user_data;

	DTP("on_clicked()\n");

  // Make window non-modal
	gtk_grab_remove(Dialog);

	gtk_widget_hide(Dialog);
  // Close window
  gtk_widget_destroy(Dialog);
  Dialog = NULL;

	if (DCallBack) (*DCallBack)(Pos,DUserData);
}

GtkWidget*
MessageDlg(char *Message,char *Title,char *Buttons,void (*Callback)(int,gpointer),gpointer UserData)
{
  GtkWidget *dialog_vbox1;
  GtkWidget *LText;
  GtkWidget *dialog_action_area1;
  GtkWidget *hbox1;
  GtkWidget *hbuttonbox1;
  GtkWidget *Button;
  GtkAccelGroup *accel_group;
	char *B = strdup(Buttons),*B2 = B,*Label;
	int n;
	
	DTP("MessageDlg()\n");

	DCallBack = Callback;
	DUserData = UserData;

  accel_group = gtk_accel_group_new ();

  Dialog = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (Dialog), Title);
  gtk_window_set_policy (GTK_WINDOW (Dialog), TRUE, TRUE, FALSE);

  dialog_vbox1 = GTK_DIALOG (Dialog)->vbox;
  gtk_widget_show (dialog_vbox1);

  LText = gtk_label_new (Message);
  gtk_widget_ref (LText);
  gtk_widget_show (LText);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), LText, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (LText), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (LText), TRUE);

  dialog_action_area1 = GTK_DIALOG (Dialog)->action_area;
  gtk_widget_show (dialog_action_area1);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area1), 10);

  hbox1 = gtk_hbox_new (TRUE, 5);
  gtk_widget_ref (hbox1);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), hbox1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox1), 10);

  hbuttonbox1 = gtk_hbutton_box_new ();
  gtk_widget_show (hbuttonbox1);
  gtk_box_pack_start (GTK_BOX (hbox1), hbuttonbox1, TRUE, TRUE, 0);

	/* Add buttons */
	n=0;
	while(*B2) {
		Label = B2;
		while((*B2) && (*B2 != '|')) B2++;

		if (*B2) *B2++=0;

		if (strlen(Label) == 0) continue;

		Button = gtk_button_new_with_label (Label);
  	gtk_widget_ref (Button);
  	gtk_widget_show (Button);
	  gtk_container_add (GTK_CONTAINER (hbuttonbox1), Button);

		if ((strcasecmp(Label,"OK") == 0) || (strcasecmp(Label,"Yes") == 0)) {
			gtk_widget_add_accelerator (Button, "clicked", accel_group, GDK_Return, 0, GTK_ACCEL_VISIBLE);
			gtk_widget_add_accelerator (Button, "clicked", accel_group, GDK_KP_Enter, 0, GTK_ACCEL_VISIBLE);
		}
		else if (strcasecmp(Label,"Cancel") == 0) {
			gtk_widget_add_accelerator (Button, "clicked", accel_group, GDK_Escape, 0, GTK_ACCEL_VISIBLE);
		}

		gtk_signal_connect (GTK_OBJECT (Button), "clicked", GTK_SIGNAL_FUNC (on_clicked), (gpointer)n++);
	}

  gtk_window_add_accel_group (GTK_WINDOW (Dialog), accel_group);

	free(B);

	gtk_widget_show(Dialog);
	gtk_grab_add(Dialog);

  return Dialog;
}

