/********\
*        *
*  Text  *
*        *
\********/

#ifndef GTKFIG_TEXT_H
#define GTKFIG_TEXT_H

#include "textobject.h"

/*
 * Text
 */

class TCADText : public TCADTextObject {
protected:
  gchar *Text;
  int Lines;
  int TextLength;  // Includes \0 at the end

  // Exports text to FIG format
  void ExportFigText(FILE *Fl);

  // Exports text to PS format
  void ExportPSText(FILE *Fl);

	// Returns text's top left corner
	void GetTextXY(int &X,int &Y,gboolean ReverseY=false);
public:
  TCADText(TCADSheet *Sheet);
  ~TCADText();
  virtual void Save(TCADSaveStream *Fl);
  virtual void SaveProperties(TCADSaveStream *Fl);
  virtual char LoadProperty(TCADLoadStream *Fl,char *ID);
  virtual void Export(FILE *Fl,TExportFormat Format);

  virtual gchar *GetText();
  virtual void SetText(gchar *Text);

  virtual void Draw(TCADView *View,GdkRegion *Region,int MagA,int MagB);

  virtual void Select(GdkRectangle *RefreshRect);

	virtual void GetOffsets(int &TOff,int &BOff,int &LOff,int &ROff);
};


#endif
